/*
 * 外部 JavaScript ファイルローダー
 *
 *
 * Version 0.0.0.1
 *
 * このプログラムのライセンスについて。
 * このプログラムは、MITライセンス(The MIT License)の元で公開します。
 * Released under the MIT Licenses.
 *
 * ライセンスの原文は、以下のURLを参照してください。
 * http://www.yscjp.com/licenses/MIT_LICENSE.txt
 *
 * Copyright (c) 2012 Yagyu Teru, http://yscjp.com/
 *
 */
var com;
if (!com) com = {};
if (!com.yscjp) com.yscjp = {};
if (!com.yscjp.jsapp) com.yscjp.jsapp = {};

com.yscjp.jsapp.JsAutoLoader = function () {};
(function() {

    var site = "";
    var contents = "";
    var page = "";
    var version = "";

    /*
     * 当該ページのmeta要素に指定されている情報を取得する。
     */
    var metaList = document.getElementsByTagName("META");
    for (var i = 0; i < metaList.length; i++) {

        var meta = metaList.item(i);
        var name = meta.name;
        switch (name) {
        case "com_yscjp_vctrl_SITE" :
            site = meta.content;
            break;
        case "com_yscjp_vctrl_CONTENTS" :
            contents = meta.content;
            break;
        case "com_yscjp_vctrl_PAGE" :
            page = meta.content;
            break;
        case "com_yscjp_vctrl_VERSION" :
            version = meta.content;
            break;
        }
    }

    /*
     * URLのクエリに指定されている情報で上書きする。
     */
    var params = new Object();
    var query = window.location.search;
    if (0 != query.length) {

        /*
         * 先頭の'?'を削除します。
         */
        query = query.replace(/\?/, "");

        /*
         * &で分割します。
         */
        var queries = query.split('&');
        for (var i = 0; i < queries.length; i++) {

            var param = queries[i].split('=');
            params[param[0]] = param[1];
        }
    }

    var value;
    value = params["com_yscjp_vctrl_SITE"];
    if (value) {
        site = value;
    }
    value = params["com_yscjp_vctrl_CONTENTS"];
    if (value) {
        contents = value;
    }
    value = params["com_yscjp_vctrl_PAGE"];
    if (value) {
        page = value;
    }
    value = params["com_yscjp_vctrl_VERSION"];
    if (value) {
        version = value;
    }

    var baseUrl = "";
    var scripts = document.getElementsByTagName("SCRIPT");
    for (var i = 0; i < scripts.length; i++) {

        var src = scripts.item(i).src;
        if (null == src || 0 == src.length) {

            continue;
        }

        if (null == src.match(/jsautoloader.js/)) {

            continue;
        }

        baseUrl = src.replace(/jsautoloader\.js.*$/, "");
        break;
    }

    var url = baseUrl + "jsvctrl.js";
    url += "?com_yscjp_vctrl_SITE=" + site +
           "&com_yscjp_vctrl_CONTENTS=" + contents +
           "&com_yscjp_vctrl_PAGE=" + page +
           "&com_yscjp_vctrl_VERSION=" + version +
           "&" + new Date().getTime();

    document.writeln("<script type=\"text/javascript\" src=\"" + url + "\"></script>");

    com.yscjp.jsapp.JsAutoLoader.getKey = function () {

        return site + "_" + contents + "_" + page + "_" + version;
    };

    com.yscjp.jsapp.JsAutoLoader.getSite = function () {

        return site;
    };

    com.yscjp.jsapp.JsAutoLoader.getContents = function () {

        return contents;
    };

    com.yscjp.jsapp.JsAutoLoader.getPage = function () {

        return page;
    };

    com.yscjp.jsapp.JsAutoLoader.getVersion = function () {

        return version;
    };

    com.yscjp.jsapp.JsAutoLoader.getBaseUrl = function () {

        return baseUrl;
    };

})();
